Index: modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/dli/workflows/nodes/feeding/DatabaseFeederWorker.java
===================================================================
--- modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/dli/workflows/nodes/feeding/DatabaseFeederWorker.java	(revision 40968)
+++ modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/dli/workflows/nodes/feeding/DatabaseFeederWorker.java	(revision 40969)
@@ -8,6 +8,9 @@
 import eu.dnetlib.msro.dli.workflows.nodes.transform.DLIUtils;
 import eu.dnetlib.msro.workflows.dli.manager.DLIDBManager;
 import eu.dnetlib.msro.workflows.dli.model.*;
+import eu.dnetlib.msro.workflows.dli.publisher.PublisherConfigurationParameters;
+import eu.dnetlib.msro.workflows.dli.publisher.PublisherResolver;
+import eu.dnetlib.msro.workflows.dli.publisher.PublisherResolverRule;
 import org.apache.commons.logging.Log;
 import org.apache.commons.logging.LogFactory;
 
@@ -59,6 +62,8 @@
      */
     private final String terminatorQueue;
 
+    private final PublisherResolver publisherResolver;
+
     /**
      * Instantiates a new enrich feeder.
      *
@@ -69,7 +74,7 @@
      * @param terminatorQueue the terminator queue
      */
     public DatabaseFeederWorker(final BlockingQueue<String> inputQueue, final DLIRecordParser parser, final DLIDBManager manager, final String namespace,
-                                final String terminatorQueue) {
+                                final String terminatorQueue, final PublisherResolver resolver) {
         super();
         this.inputQueue = inputQueue;
         this.parser = parser;
@@ -77,6 +82,7 @@
         this.namespace = namespace;
         this.terminatorQueue = terminatorQueue;
         this.buffer = Lists.newArrayList();
+        this.publisherResolver = resolver;
     }
 
     /**
@@ -103,16 +109,17 @@
         while (nextRecord != null && nextRecord != terminatorQueue) {
             try {
                 final DLIObject extractedObject = parser.parseRecord(nextRecord);
-                if (extractedObject.getDatasourceProvenance() != null) {
-                    for (DLIProvenance prov : extractedObject.getDatasourceProvenance()) {
-                        extractedObject.fixContribution(prov);
+                if (extractedObject != null) {
+                    if (extractedObject.getDatasourceProvenance() != null) {
+                        for (DLIProvenance prov : extractedObject.getDatasourceProvenance()) {
+                            extractedObject.fixContribution(prov);
+                        }
                     }
-                }
-                if (extractedObject != null) {
                     if (extractedObject.getCompletionStatus() == null) {
                         extractedObject.setCompletionStatus(DLICompletionStatus.complete.toString());
                     }
                     fixRecordProvenance(extractedObject);
+                    fixRecordPublisher(extractedObject, publisherResolver.getParameters().getSource());
                     normalizeDOI(extractedObject);
                     if (extractRelation(extractedObject)) {
                         buffer.add(extractedObject);
@@ -143,6 +150,46 @@
         return true;
     }
 
+    private void fixRecordPublisher(final DLIObject extractedObject, final List<PublisherResolverRule> source) {
+        if (publisherResolver== null || publisherResolver.getParameters()==null)
+            return;
+        if(source !=null && source.size()>0){
+            for (PublisherResolverRule item : source ) {
+                if(item.getField()==null) {
+                    extractedObject.getDatasourceProvenance().get(0).setPublisher(item.getKey());
+                }
+                else {
+                    String inputValue = "";
+                    if (PublisherResolver.PID_TYPE.equals(item.getField())) {
+                        inputValue = extractedObject.getPidType();
+                    }
+
+                    if (PublisherResolver.OBJECT_TYPE.equals(item.getField())) {
+                        inputValue = extractedObject.getType().toString();
+                    }
+                    if (PublisherResolver.PID.equals(item.getField())) {
+                        inputValue = extractedObject.getPid();
+                    }
+                    if(checkConditionForPublisher(inputValue, item.getRegExp(), extractedObject, item.getKey())== true)
+                        return;
+                }
+            }
+        }
+    }
+
+
+
+    private boolean checkConditionForPublisher(final String value, final String regExp, final DLIObject inputObject, final String key) {
+        if(value== null)
+            return false;
+        if(value.toLowerCase().trim().matches(regExp)) {
+            inputObject.getDatasourceProvenance().get(0).setPublisher(key);
+            return true;
+        }
+        return  false;
+    }
+
+
     /**
      * Extract relation.
      *
@@ -156,6 +203,7 @@
             for (DLIRelation relation : relations) {
                 DLIObject currentObject = extractRecordFromRelation(input, relation);
                 if (currentObject != null) {
+                    fixRecordPublisher(currentObject, publisherResolver.getParameters().getTarget());
                     buffer.add(currentObject);
                     addedOne = true;
                 }
@@ -209,7 +257,7 @@
 
         // SET THE PROVENANCE STATUS INCOMPLETE, PROVISION MODE COLLECTED
         DLIProvenance dbObjectProvenance =
-                new DLIProvenance(namespace, DLIProvisionMode.collected.toString(), DLICompletionStatus.incomplete.toString(), null, null, true);
+                new DLIProvenance(input.getDatasourceProvenance().get(0).getDatasource(), DLIProvisionMode.collected.toString(), DLICompletionStatus.incomplete.toString(), null, null, true);
         dbObject.setDatasourceProvenance(Lists.newArrayList(dbObjectProvenance));
         dbObject.fixContribution(dbObjectProvenance);
 
Index: modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/dli/workflows/nodes/ObtainDataSourceParamsJobNode.java
===================================================================
--- modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/dli/workflows/nodes/ObtainDataSourceParamsJobNode.java	(revision 40968)
+++ modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/dli/workflows/nodes/ObtainDataSourceParamsJobNode.java	(revision 40969)
@@ -1,42 +1,48 @@
 package eu.dnetlib.msro.dli.workflows.nodes;
 
-import javax.annotation.Resource;
-
 import com.googlecode.sarasvati.Arc;
 import com.googlecode.sarasvati.NodeToken;
-
 import eu.dnetlib.enabling.is.lookup.rmi.ISLookUpService;
 import eu.dnetlib.enabling.locators.UniqueServiceLocator;
 import eu.dnetlib.miscutils.datetime.DateUtils;
 import eu.dnetlib.msro.workflows.nodes.SimpleJobNode;
+import eu.dnetlib.msro.workflows.util.WorkflowsConstants;
+import org.apache.commons.logging.Log;
+import org.apache.commons.logging.LogFactory;
 
+import javax.annotation.Resource;
+
 public class ObtainDataSourceParamsJobNode extends SimpleJobNode {
 
-	private String providerId;
 
-	@Resource
-	private UniqueServiceLocator serviceLocator;
+    private static final Log log = LogFactory.getLog(ObtainDataSourceParamsJobNode.class);
+    private String providerId;
 
-	@Override
-	protected String execute(final NodeToken token) throws Exception {
-		final String query = "let $x := /*[.//RESOURCE_IDENTIFIER/@value='" + providerId + "']//EXTRA_FIELDS\n"
-				+ "return concat($x/FIELD[./key='DataSourceId']/value, ' @@@ ', $x/FIELD[./key='NamespacePrefix']/value)";
+    @Resource
+    private UniqueServiceLocator serviceLocator;
 
-		final String[] arr = serviceLocator.getService(ISLookUpService.class).getResourceProfileByQuery(query).split("@@@");
+    @Override
+    protected String execute(final NodeToken token) throws Exception {
+        final String query = "let $x := /*[.//RESOURCE_IDENTIFIER/@value='" + providerId + "']//EXTRA_FIELDS\n"
+                + "return concat($x/FIELD[./key='DataSourceId']/value, ' @@@ ', $x/FIELD[./key='NamespacePrefix']/value)";
 
-		token.getEnv().setAttribute("parentDatasourceId", arr[0].trim());
-		token.getEnv().setAttribute("namespacePrefix", arr[1].trim());
-		token.getEnv().setAttribute("dateOfCollection", DateUtils.now_ISO8601());
+        final String[] arr = serviceLocator.getService(ISLookUpService.class).getResourceProfileByQuery(query).split("@@@");
 
-		return Arc.DEFAULT_ARC;
-	}
+        token.getEnv().setAttribute("parentDatasourceId", arr[0].trim());
+        token.getEnv().setAttribute("namespacePrefix", arr[1].trim());
+        token.getEnv().setAttribute("dateOfCollection", DateUtils.now_ISO8601());
 
-	public String getProviderId() {
-		return providerId;
-	}
+        log.info(WorkflowsConstants.DATAPROVIDER_ID + " : " + token.getFullEnv().getAttribute(WorkflowsConstants.DATAPROVIDER_ID));
 
-	public void setProviderId(final String providerId) {
-		this.providerId = providerId;
-	}
+        return Arc.DEFAULT_ARC;
+    }
 
+    public String getProviderId() {
+        return providerId;
+    }
+
+    public void setProviderId(final String providerId) {
+        this.providerId = providerId;
+    }
+
 }
Index: modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/resolver/CrossRefParser.java
===================================================================
--- modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/resolver/CrossRefParser.java	(revision 40968)
+++ modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/resolver/CrossRefParser.java	(revision 40969)
@@ -27,7 +27,7 @@
 	private static final Log log = LogFactory.getLog(CrossRefParser.class); // NOPMD by marko on 11/24/08 5:02 PM
 
 	/** The Constant CROSSREF_NS_PREFIX. */
-	public static final String CROSSREF_NS_PREFIX = "crs";
+	public static final String CROSSREF_NS_PREFIX = "dli::crossref";
 
 	/**
 	 * Parses the record.
Index: modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/resolver/DataciteDOIResolver.java
===================================================================
--- modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/resolver/DataciteDOIResolver.java	(revision 40968)
+++ modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/resolver/DataciteDOIResolver.java	(revision 40969)
@@ -28,7 +28,7 @@
  */
 public class DataciteDOIResolver implements DOIResolver {
 
-	public static final String DATACITE_NS_PREFIX = "dctr";
+	public static final String DATACITE_NS_PREFIX = "dli::dataciteResolver";
 
 	/** The cache. */
 	@Resource(name = "dataciteDOICache")
@@ -38,7 +38,7 @@
 	private static final Log log = LogFactory.getLog(DataciteDOIResolver.class); // NOPMD by marko on 11/24/08 5:02 PM
 
 	/** The Constant baseURL. */
-	private final static String baseURL = "http://search.datacite.org/api?wt=json&fl=doi,title,contributor,creator&q=doi:";
+	private final static String baseURL = "http://search.datacite.org/api?wt=json&fl=doi,title,contributor,creator,publisher&q=doi:";
 
 	@Override
 	public DLIObject retrieveDOI(final String doi, final String doiType) {
@@ -135,12 +135,16 @@
 				responseObj.setAuthors(authors.toArray(new String[0]));
 
 				DLIProvenance provenance = new DLIProvenance(DATACITE_NS_PREFIX, "resolved", "complete", null, null, true);
+
+				JsonElement publisherElement = ((JsonObject) elem).get("publisher");
+				if (publisherElement != null && !publisherElement.isJsonNull()) {
+					provenance.setPublisher(publisherElement.getAsString());
+				}
 				responseObj.fixContribution(provenance);
 				responseObj.setDatasourceProvenance(Lists.newArrayList(provenance));
 				return responseObj;
+	 			}
 
-			}
-
 			return null;
 		}
 		return null;
Index: modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/resolver/PubMedResolver.java
===================================================================
--- modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/resolver/PubMedResolver.java	(revision 40968)
+++ modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/resolver/PubMedResolver.java	(revision 40969)
@@ -32,7 +32,7 @@
 
 	private static final String query = "http://www.ebi.ac.uk/europepmc/webservices/rest/search/query=%s&format=json";
 
-	private static final String PUBMED_NS_PREFIX = "pbmed";
+	private static final String PUBMED_NS_PREFIX = "dli::pbmedResolver";
 
 	/**
 	 * {@inheritDoc}
Index: modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/manager/DLIDBIterator.java
===================================================================
--- modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/manager/DLIDBIterator.java	(revision 40968)
+++ modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/manager/DLIDBIterator.java	(revision 40969)
@@ -36,6 +36,7 @@
     private ResultSet inputResutlSet;
     private DLIObject dliObject;
     private Map<String, Pair<String, Boolean>> datasourceMap;
+    private Map<String, String> publisherByNameMap;
     private Function<DLIObject, T> converter;
     private boolean exportIntersection = false;
 
@@ -46,7 +47,8 @@
         this.manager = manager;
         this.inputDatasource = inputDatasource;
         this.exportIntersection = exportIntersection;
-        datasourceMap = manager.getDataSourceByNameMaps();
+        this.datasourceMap = manager.getDataSourceByIDMaps();
+        this.publisherByNameMap = manager.getPublisherByNameMap();
         this.limitRelation = limitRelation;
         this.converter = converter;
         nextObject = constructNextObject();
@@ -205,11 +207,9 @@
         JsonElement jElement = new JsonParser().parse("[" + fixedInput + "]");
         if (jElement.isJsonNull()) return null;
         JsonArray datasourcesArray = jElement.getAsJsonArray();
-
         if (datasourcesArray.size() == 0)
             return null;
         Map<String, DLIProvenance> provenanceMaps = Maps.newHashMap();
-
         for (JsonElement currentDatasource : datasourcesArray) {
             String ds_id = getObject(currentDatasource, "ds_id");
             String provision_mode = getObject(currentDatasource, "provision_mode");
@@ -216,11 +216,18 @@
             String completion_status_prov = getObject(currentDatasource, "completion_status");
             String contribution = getObject(currentDatasource, "contribution");
             String collection_date = getObject(currentDatasource, "collection_date");
+            String publisher = getObject(currentDatasource, "publisher");
+            String publisherId = null;
+            if(publisher!=null && !"null".equals(publisher)) {
+                if(publisherByNameMap.containsKey(publisher.toLowerCase().trim())) {
+                    publisherId = publisherByNameMap.get(publisher.toLowerCase().trim());
+                }
+            }
             Pair<String, Boolean> ds_info = datasourceMap.get(ds_id);
             ds_id = ds_info.getKey();
             final boolean visible = ds_info.getValue();
             if (visible || exportIntersection) {
-                provenanceMaps.put(ds_id, new DLIProvenance(ds_id, provision_mode, completion_status_prov, contribution, collection_date, visible));
+                provenanceMaps.put(ds_id, new DLIProvenance(ds_id, provision_mode, completion_status_prov, contribution, collection_date, visible,publisherByNameMap.get(ds_id.toLowerCase().trim()), publisher, publisherId));
             }
 
         }
Index: modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/publisher/PublisherResolverRule.java
===================================================================
--- modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/publisher/PublisherResolverRule.java	(nonexistent)
+++ modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/publisher/PublisherResolverRule.java	(revision 40969)
@@ -0,0 +1,46 @@
+package eu.dnetlib.msro.workflows.dli.publisher;
+
+/**
+ * Created by Sandro La Bruzzo on 1/13/16.
+ */
+public class PublisherResolverRule {
+
+    private String field;
+    private String regExp;
+    private int priority;
+    private String key;
+
+
+    public String getField() {
+        return field;
+    }
+
+    public void setField(String field) {
+        this.field = field;
+    }
+
+    public String getRegExp() {
+        return regExp;
+    }
+
+    public void setRegExp(String regExp) {
+        this.regExp = regExp;
+    }
+
+    public int getPriority() {
+        return priority;
+    }
+
+    public void setPriority(int priority) {
+        this.priority = priority;
+    }
+
+
+    public String getKey() {
+        return key;
+    }
+
+    public void setKey(String key) {
+        this.key = key;
+    }
+}
Index: modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/publisher/PublisherResolverRuleDeserializer.java
===================================================================
--- modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/publisher/PublisherResolverRuleDeserializer.java	(nonexistent)
+++ modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/publisher/PublisherResolverRuleDeserializer.java	(revision 40969)
@@ -0,0 +1,58 @@
+package eu.dnetlib.msro.workflows.dli.publisher;
+
+import com.google.gson.*;
+
+import java.lang.reflect.Type;
+import java.util.ArrayList;
+import java.util.List;
+
+/**
+ * Created by Sandro La Bruzzo on 1/13/16.
+ */
+public class PublisherResolverRuleDeserializer implements JsonDeserializer<PublisherConfigurationParameters> {
+
+    private final static String PRIORITY_KEY = "priority";
+    private final static String FIELD_KEY = "field";
+    private final static String REGEXP_KEY = "regExp";
+    private final static String RESULT_KEY = "key";
+
+
+    @Override
+    public PublisherConfigurationParameters deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
+        try {
+            final JsonObject root = json.getAsJsonObject();
+            final JsonArray source = root.get("source").getAsJsonArray();
+            final JsonArray target = root.get("target").getAsJsonArray();
+            final List<PublisherResolverRule> sourceResolver = new ArrayList<PublisherResolverRule>();
+            final List<PublisherResolverRule> targetResolver = new ArrayList<PublisherResolverRule>();
+            populateResolver(source, sourceResolver);
+            populateResolver(target, targetResolver);
+            PublisherConfigurationParameters parameters = new PublisherConfigurationParameters();
+            parameters.setSource(sourceResolver);
+            parameters.setTarget(targetResolver);
+            return parameters;
+
+
+        } catch (Throwable e) {
+            throw new JsonParseException("Error on parsing json", e);
+        }
+
+    }
+
+    protected void populateResolver(JsonArray source, List<PublisherResolverRule> sourceResolver) {
+        for (JsonElement item : source) {
+            PublisherResolverRule currentResolver = new PublisherResolverRule();
+
+            final JsonObject currentObject = item.getAsJsonObject();
+            if (currentObject.get(PRIORITY_KEY) != null && !currentObject.get(PRIORITY_KEY).isJsonNull())
+                currentResolver.setPriority(currentObject.get(PRIORITY_KEY).getAsInt());
+            if (currentObject.get(FIELD_KEY) != null && !currentObject.get(FIELD_KEY).isJsonNull())
+                currentResolver.setField(currentObject.get(FIELD_KEY).getAsString());
+            if (currentObject.get(REGEXP_KEY) != null && !currentObject.get(REGEXP_KEY).isJsonNull())
+                currentResolver.setRegExp(currentObject.get(REGEXP_KEY).getAsString());
+            if (currentObject.get(RESULT_KEY) != null && !currentObject.get(RESULT_KEY).isJsonNull())
+                currentResolver.setKey(currentObject.get(RESULT_KEY).getAsString());
+            sourceResolver.add(currentResolver);
+        }
+    }
+}
Index: modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/publisher/PublisherResolver.java
===================================================================
--- modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/publisher/PublisherResolver.java	(nonexistent)
+++ modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/publisher/PublisherResolver.java	(revision 40969)
@@ -0,0 +1,36 @@
+package eu.dnetlib.msro.workflows.dli.publisher;
+
+import com.google.gson.Gson;
+import com.google.gson.GsonBuilder;
+import eu.dnetlib.enabling.is.lookup.rmi.ISLookUpException;
+import eu.dnetlib.enabling.is.lookup.rmi.ISLookUpService;
+import eu.dnetlib.enabling.locators.UniqueServiceLocator;
+import org.springframework.beans.factory.annotation.Autowired;
+
+import java.util.List;
+
+/**
+ * Created by Sandro La Bruzzo on 1/13/16.
+ */
+public class PublisherResolver {
+
+
+    public static String PID_TYPE    = "pidType";
+    public static String PID         = "pid";
+    public static String OBJECT_TYPE = "objectType";
+
+
+
+    private PublisherConfigurationParameters parameters;
+
+    private static final String queryTemplate = "//RESOURCE_PROFILE[.//RESOURCE_IDENTIFIER/@value/string()='%s']//FIELD[key = 'provConfigParameters']/value/text()";
+
+    public PublisherConfigurationParameters getParameters() {
+        return parameters;
+    }
+
+    public void setParameters(PublisherConfigurationParameters parameters) {
+        this.parameters = parameters;
+    }
+
+}
Index: modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/publisher/PublisherConfigurationParameters.java
===================================================================
--- modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/publisher/PublisherConfigurationParameters.java	(nonexistent)
+++ modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/publisher/PublisherConfigurationParameters.java	(revision 40969)
@@ -0,0 +1,29 @@
+package eu.dnetlib.msro.workflows.dli.publisher;
+
+import java.util.List;
+
+/**
+ * Created by Sandro La Bruzzo on 1/13/16.
+ */
+public class PublisherConfigurationParameters {
+
+    private List<PublisherResolverRule> source;
+    private List<PublisherResolverRule> target;
+
+
+    public List<PublisherResolverRule> getSource() {
+        return source;
+    }
+
+    public void setSource(List<PublisherResolverRule> source) {
+        this.source = source;
+    }
+
+    public List<PublisherResolverRule> getTarget() {
+        return target;
+    }
+
+    public void setTarget(List<PublisherResolverRule> target) {
+        this.target = target;
+    }
+}
Index: modules/dnet-openaire_dli-workflows/trunk/src/main/resources/eu/dnetlib/msro/dli_openaire/workflows/repo-hi/xslt/ingest_oai.xslt
===================================================================
--- modules/dnet-openaire_dli-workflows/trunk/src/main/resources/eu/dnetlib/msro/dli_openaire/workflows/repo-hi/xslt/ingest_oai.xslt	(revision 40968)
+++ modules/dnet-openaire_dli-workflows/trunk/src/main/resources/eu/dnetlib/msro/dli_openaire/workflows/repo-hi/xslt/ingest_oai.xslt	(revision 40969)
@@ -10,6 +10,8 @@
     <xsl:param name="repositoryId" />
     <xsl:param name="namespacePrefix"></xsl:param>
     <xsl:param name="dataprovider_id"></xsl:param>
+    <xsl:param name="parentDatasourceId"></xsl:param>
+
     <xsl:variable name="status" select="/*[local-name() = 'record']/*[local-name() = 'header']/@status" />
     <xsl:variable name="doi" select="//*[local-name()='header']/*[local-name()='identifier']"></xsl:variable>  
     <xsl:template match="/">
@@ -27,7 +29,8 @@
                 <dri:recordIdentifier><xsl:value-of select="$doi"/></dri:recordIdentifier>
                 <dri:dateOfCollection><xsl:value-of select="datetime:dateTime()"/></dri:dateOfCollection>
                 <dri:repositoryId><xsl:value-of select="$dataprovider_id"/></dri:repositoryId>
-                <dri:datasourceprefix><xsl:value-of select="$namespacePrefix"/></dri:datasourceprefix>                
+                <dri:datasourceprefix><xsl:value-of select="$namespacePrefix"/></dri:datasourceprefix>
+                <dri:datasourceID><xsl:value-of select="$parentDatasourceId"/></dri:datasourceID>
                 <!-- Bulk copy of old header -->
                 <xsl:for-each select="/*[local-name() = 'record']/*[local-name() = 'header']//*[namespace-uri()='http://www.openarchives.org/OAI/2.0/']">
                     <xsl:copy-of select="." />
Index: modules/dnet-openaire_dli-workflows/trunk/src/main/resources/eu/dnetlib/msro/dli_openaire/workflows/repo-hi/xslt/ingest_oai_datacite.xslt
===================================================================
--- modules/dnet-openaire_dli-workflows/trunk/src/main/resources/eu/dnetlib/msro/dli_openaire/workflows/repo-hi/xslt/ingest_oai_datacite.xslt	(revision 40968)
+++ modules/dnet-openaire_dli-workflows/trunk/src/main/resources/eu/dnetlib/msro/dli_openaire/workflows/repo-hi/xslt/ingest_oai_datacite.xslt	(revision 40969)
@@ -10,6 +10,7 @@
     <xsl:param name="repositoryId" />
     <xsl:param name="namespacePrefix"></xsl:param>
     <xsl:param name="dataprovider_id"></xsl:param>
+    <xsl:param name="parentDatasourceId"></xsl:param>
     <xsl:variable name="status" select="/*[local-name() = 'record']/*[local-name() = 'header']/@status" />
     <xsl:variable name="doi" select="//*[local-name()='resource']/*[local-name()='identifier']"></xsl:variable>  
     <xsl:template match="/">
@@ -27,7 +28,8 @@
                 <dri:recordIdentifier><xsl:value-of select="$doi"/></dri:recordIdentifier>
                 <dri:dateOfCollection><xsl:value-of select="datetime:dateTime()"/></dri:dateOfCollection>
                 <dri:repositoryId><xsl:value-of select="$dataprovider_id"/></dri:repositoryId>
-                <dri:datasourceprefix><xsl:value-of select="$namespacePrefix"/></dri:datasourceprefix>                
+                <dri:datasourceprefix><xsl:value-of select="$namespacePrefix"/></dri:datasourceprefix>
+                <dri:datasourceID><xsl:value-of select="$parentDatasourceId"/></dri:datasourceID>
                 <!-- Bulk copy of old header -->
                 <xsl:for-each select="/*[local-name() = 'record']/*[local-name() = 'header']//*[namespace-uri()='http://www.openarchives.org/OAI/2.0/']">
                     <xsl:copy-of select="." />
Index: modules/dli-service-portal/trunk/DLI.py
===================================================================
--- modules/dli-service-portal/trunk/DLI.py	(revision 40968)
+++ modules/dli-service-portal/trunk/DLI.py	(revision 40969)
@@ -116,7 +116,7 @@
     if action == 'query' and query is not None:
         q = QueryResolver(host, base_dnet_url)
         try:
-            result = q.query(q=query, browse_fields=["entitytype", "provenance"], start=start, only_result=only_result,
+            result = q.query(q=query, browse_fields=["entitytype", "provenance", "publisher"], start=start, only_result=only_result,
                              filter_query=filter_query)
         except Exception as e:
             print e
Index: modules/dli-service-portal/trunk/DLIQueryResolver.py
===================================================================
--- modules/dli-service-portal/trunk/DLIQueryResolver.py	(revision 40968)
+++ modules/dli-service-portal/trunk/DLIQueryResolver.py	(revision 40969)
@@ -12,7 +12,8 @@
         self.solr_server = pysolr.Solr(self.solr_url)
         self.base_url_dnet = base_url_dnet
         self.facet_renaming = {'entitytype': "Typology", 'provenance': "Content Provider",
-                               "Content Provider": 'provenance', "Typology": 'entitytype'}
+                               "Content Provider": 'provenance', "Typology": 'entitytype',
+                               "publisher":"publisher"}
 
     def get_facet(self, facet, query=None):
         data = []
@@ -29,6 +30,10 @@
         data.append({'facet': self.facet_renaming[f], 'query_name': f,
                      'values': [{'key': facet[f][i], 'value': facet[f][i + 1]} for i in range(0, len(facet[f]), 2)]})
 
+        f = 'publisher'
+        data.append({'facet': self.facet_renaming[f], 'query_name': f,
+                     'values': [{'key': facet[f][i], 'value': facet[f][i + 1]} for i in range(0, len(facet[f]), 2)]})
+
         return data
 
     def get_item(self, persistent_identifier):
Index: modules/dli-service-portal/trunk/DLI_ObjectResolver.py
===================================================================
--- modules/dli-service-portal/trunk/DLI_ObjectResolver.py	(revision 40968)
+++ modules/dli-service-portal/trunk/DLI_ObjectResolver.py	(revision 40969)
@@ -58,7 +58,7 @@
 
             if "titles" in data:
                 if len(data['titles']) > 0:
-                    self.title = data['titles'][0]
+                    self.title = data['titles'][0].replace('["','').replace('"]','')
             self.authors = data['authors']
             if 'type' in data:
                 self.objectType = data['type']
@@ -70,6 +70,15 @@
                     item = {'name': provenance['datasource'], 'completionStatus': provenance['completionStatus'],
                             'provisionMode': provenance['provisionMode'],
                             'collectionDate': provenance['collectionDate']}
+
+                    if 'datasourceId' in provenance:
+                        item['datasourceId'] = provenance['datasourceId']
+
+                    if 'publisher' in provenance:
+                        item['publisher'] =provenance['publisher']
+                    if 'publisherId' in provenance:
+                        item['publisherId'] =provenance['publisherId']
+
                     self.provenance_record.append(item)
             if 'relations' in data:
                 for rels in data['relations']:
Index: modules/dnet-openaire_dli-workflows/trunk/src/test/java/PublisherResolverTest.java
===================================================================
--- modules/dnet-openaire_dli-workflows/trunk/src/test/java/PublisherResolverTest.java	(nonexistent)
+++ modules/dnet-openaire_dli-workflows/trunk/src/test/java/PublisherResolverTest.java	(revision 40969)
@@ -0,0 +1,17 @@
+import eu.dnetlib.msro.workflows.dli.publisher.PublisherResolver;
+import junit.framework.Assert;
+import org.junit.Test;
+
+/**
+ * Created by Sandro La Bruzzo on 1/13/16.
+ */
+public class PublisherResolverTest {
+
+    private final String jsonInput = "{source: [{priority: 0, field:\"any\",  key:'elsevier'}], target: [{priority: 0, field:\"pidType\", regExp:\"doi\", key:'elsevier'}]}";
+
+    @Test
+    public void testJson() {
+
+    }
+
+}
